#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <opencv.hpp>


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButtonWebcam_clicked()
{
    IplImage* test=0;
    CvCapture* capture = 0;
            capture   = cvCaptureFromCAM(0);
            if(capture)
            {
                    test = cvQueryFrame(capture);
                    int width = (int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_WIDTH );
                    int height= (int)cvGetCaptureProperty( capture, CV_CAP_PROP_FRAME_HEIGHT);
                    printf("width %d height %d\n",width,height);

                    IplImage* frame    = cvCreateImage(cvSize(width,height), IPL_DEPTH_8U  ,3);
                    IplImage* gray     = cvCreateImage(cvSize(width,height), IPL_DEPTH_8U  ,1);
                    IplImage* gaussian = cvCreateImage(cvSize(width,height), IPL_DEPTH_8U  ,1);

                    while(cvGrabFrame(capture))
                    {
                            frame = cvRetrieveFrame(capture);
                            cvNamedWindow("Capture Webcam", 0);
                            cvShowImage("Capture Webcam",frame);
                            cvConvertImage(frame,gray,1);
                            cvWaitKey(1);
                            //cvCvtColor(frame,gray,CV_RGB2GRAY); //!!flip the result!!
                            cvSmooth(gray,gaussian,CV_GAUSSIAN,25,25);
                            cvNamedWindow("Lissage", 0);
                            cvShowImage("Lissage", gaussian);
                            cvWaitKey(1);
                    }
            }
            else printf("Video stream not found\n\n");
}

void MainWindow::on_pushButtonImage_clicked()
{
            IplImage* img = cvLoadImage( "luc.jpg" );  //"../luc.jpg"
            cvNamedWindow( "Luc", CV_WINDOW_AUTOSIZE );
            cvShowImage("Luc", img);
            cvWaitKey(0);
            cvReleaseImage( &img );
            cvDestroyWindow( "Luc" );



}
